
open Term

exception Unification_failure

let rec unify u v = match observe u, observe v with
  | Var x, Var y ->
      if not (var_equals x y) then bind x v
  | Var x, _ -> bind x v
  | _, Var x -> bind x u
  | Fun (f1,l1), Fun (f2,l2) ->
      if f1 <> f2 then raise Unification_failure ;
      List.iter2 unify l1 l2
